unit pe_int;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages,
  Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DsgnIntf, formspin, ComCtrls;

type
  TSpecialIntProperty = class (TIntegerProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

procedure Register;

implementation

{property editor methods}

function TSpecialIntProperty.GetAttributes:
  TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;

procedure TSpecialIntProperty.Edit;
var
  PEForm: TSpinForm;
begin
  PEForm := TSpinForm.Create (Application);
  try
    PEForm.Edit1.Text := GetValue;
    if PEForm.ShowModal = mrOK then
      SetValue (PEForm.Edit1.Text);
  finally
    PEForm.Free;
  end;
end;

procedure Register;
begin
  RegisterPropertyEditor (TypeInfo(Integer),
    TButton, '', TSpecialIntProperty);
end;

end.

